package com.test;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import com.test.model.Address;
import com.test.model.Contact;
import com.test.model.Customer;

public class TestRun
{

	public static void main(String[] args)
	{
		final Map<String, String> properties = new HashMap<String, String>();
		properties.put("javax.persistence.jdbc.user", "admin");
		properties.put("javax.persistence.jdbc.password", "admin");

		EntityManagerFactory emf = Persistence.createEntityManagerFactory("objectdb://localhost:6136/test/testDB6.odb;drop", properties);

		// test01(emf);
		test02(emf);

		emf.close();
	}

	// Query: SELECT $1 FROM com.test.virtual.model.MyCustomer $1 WHERE
	// TYPE($1)=class com.test.model.Customer
	// Exception in thread "main" [ObjectDB 2.3.4_03]
	// javax.persistence.PersistenceException
	// Attempt to store an instance of a non persistable type java.lang.Class
	// (error 303)
	// at com.objectdb.jpa.JpaQuery.getResultList(JpaQuery.java:675)
	// at com.test.TestRun.main(TestRun.java:44)
	// Caused by: com.objectdb.o.UserException: Attempt to store an instance of
	// a non persistable type java.lang.Class
	// at com.objectdb.o.MSG.d(MSG.java:61)
	// at com.objectdb.o.TYW.writeElement(TYW.java:223)
	// at com.objectdb.o.QRR.l(QRR.java:424)
	// at com.objectdb.o.QRR.g(QRR.java:230)
	// at com.objectdb.o.QRR.b(QRR.java:151)
	// at com.objectdb.jpa.JpaQuery.getResultList(JpaQuery.java:666)
	// ... 1 more
	private static void test01(EntityManagerFactory emf)
	{
		EntityManager em = emf.createEntityManager();
		em.getTransaction().begin();
		em.persist(new Contact("Contact One"));
		em.persist(new Contact("Contact Two"));
		em.persist(new Customer("Customer One"));
		em.persist(new Customer("Customer Two"));
		em.getTransaction().commit();
		em.close();

		em = emf.createEntityManager();
		CriteriaBuilder cb = em.getCriteriaBuilder();
		CriteriaQuery<Object> cq = cb.createQuery();
		Root<Customer> e = cq.from(Customer.class);
		cq.select(e);
		cq.where(cb.equal(e.type(), cb.literal(e.getJavaType())));
		System.out.println("Query: " + cq);
		List<Object> resultList = em.createQuery(cq).getResultList();
		System.out.println("Size: " + resultList.size());
		em.close();
	}

	private static void test02(EntityManagerFactory emf)
	{
		EntityManager em = emf.createEntityManager();
		Contact contact = new Contact("TEST");
		contact.getAddresses().add(new Address("1", "1", "1"));
		contact.getAddresses().add(new Address("2", "2", "2"));
		em.getTransaction().begin();
		em.persist(contact);
		em.getTransaction().commit();

		int Address_1_Count = ((Long) em.createQuery("SELECT COUNT(a) FROM com.test.virtual.model33.MyAddress a WHERE street = '1'")
		        .getSingleResult()).intValue();
		int Address_2_Count = ((Long) em.createQuery("SELECT COUNT(a) FROM com.test.virtual.model33.MyAddress a WHERE street = '2'")
		        .getSingleResult()).intValue();

		System.out.println("Address_1 Count: " + Integer.toString(Address_1_Count));
		System.out.println("Address_2 Count: " + Integer.toString(Address_2_Count));
		em.close();

		em = emf.createEntityManager();
		contact = (Contact) em.createQuery("SELECT FROM com.test.virtual.model22.MyContact").setMaxResults(1).getSingleResult();
		em.getTransaction().begin();
		Address address_1 = contact.getAddresses().get(0);

		// Remove and add address again -> will be gone
		contact.getAddresses().remove(address_1);
		contact.getAddresses().add(address_1);

		em.getTransaction().commit();

		Address_1_Count = ((Long) em.createQuery("SELECT COUNT(a) FROM com.test.virtual.model33.MyAddress a WHERE street = '1'")
		        .getSingleResult()).intValue();
		Address_2_Count = ((Long) em.createQuery("SELECT COUNT(a) FROM com.test.virtual.model33.MyAddress a WHERE street = '2'")
		        .getSingleResult()).intValue();

		System.out.println("Address_1 Count: " + Integer.toString(Address_1_Count));
		System.out.println("Address_2 Count: " + Integer.toString(Address_2_Count));
		em.close();

	}
}
