package com.test.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.OneToMany;

@Entity(name = "com.test.virtual.model22.MyContact")
public class Contact
{
	private String name = null;
	@OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
	private List<Address> addresses = null;

	public Contact(String name)
	{
		this.name = name;
	}

	public Contact()
	{
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public List<Address> getAddresses()
	{
		if (addresses == null)
		{
			addresses = new ArrayList<Address>();
		}
		return addresses;
	}

	public void addAddress(Address a)
	{
		getAddresses().add(a);
	}

	public void removeAddress(Address a)
	{
		getAddresses().remove(a);
	}
}